
public class Set<X> {

	private Node<X> start;	
	
	private int size; //variable fr die gre
	
	public Set() {			//Konstrukter der die Startwertde der liste angibt
		this.start = null;		//Startwert für "start" ist "null"
		this.size = 0;			//Startwert für die größe alos "size" ist 0
	}
	
	public boolean isEmpty() {	//Methode für den test ob die liste leer ist
		if(size == 0) {	//solange die größe noch 0 ist
			return true;		//positiver ergebnis, dass die Liste leer ist
		} else {		//ansonsten
			return false;	 //negative ergebnis, ass die liste Werte enthält
		}
	}
	
	public boolean contains(X wert) {									//Methode um herauszufinden ob ein bestimmter wert in der Liste vorhanden ist
		Node<X> current = this.start;									//initialisiert den knoten current
		while(current != null) {										//wärend der wert von current ungleicht "null" ist
		
			if(current.wert == wert) {									//wenn der Wert von current gleich dem eingegebenen "wert" ist
				return true;											//positives ergebnis für den durchgeführten test
			}
			current = current.next; 									//nächste wert von current wird zum aktuellen
		
		}
		return false;	//negatives ergebnis für den durchgeführten test
	}
	
	public void add(X wert) {
		if(contains(wert) == false) {
			this.size++;											
			
			if(this.start == null) {							
				this.start = new Node<X>(wert);			
			} else { 
				Node<X> current = this.start;		
				while (current.next != null) {				
					current = current.next;	
	
				}
				current.next = new Node<X>(wert);
			}
			
		} else {
			return;
		}
		
	}
	
	public void remove(X wert) {//methode um dne wert an einer bestimmten stelle zu entfernen
		Node<X> current = this.start;//initialisiert den Knoten current
		if(current.wert == wert) {	//wenn der aktuelle wert dem eingegebenen entspricht
			this.start = current.next;	//wird der start zur nchsten variable
			size--;	//1 wind von der gre subtrahiert
		}
			while(current.next != null) {	//wrend die nchste variable ungleich null ist
				if(current.next.wert == wert) {	//wenn der nchste wert gleich dem eingegebenen wert ist
					current.next = current.next.next;	//wird die nchste variable zur bernchsten
					size--;	//1 wird von der gre abgezogen
				} else {	//ansonsten
					current = current.next;	//wird der aktuelle wert zum nchsten
				}
			
			}
	}
	
	public Set<X> intersection(Set<X> s) {	//methode die Variablen die in beiden listen vorhanden sind in einer list zusammen
		Set<X> result = new Set<X>();	//neue Liste zur Ausgabe
		Node<X> current = this.start;	//initialisiert die liste
		while(current != null) {	//wrend current ungleich null ist
			if(s.contains(current.wert)) result.add(current.wert);	//wenn die liste s den wert enthlt dann wird der wert in die ausgabeliste hinzugefgt
			current = current.next; //current wird zur nchsten variable
		}
		return result;	//gibt die ausgabeliste zurck
	}
	
	public Set<X> union(Set<X> s) {	//Methode die alle werte aus beiden listen in eine packt
		Node<X> current = this.start;	//initialisiert die erste liste
		Node<X> current2 = s.start; //initialisiert die zweite liste
		Set<X> result = new Set<X>(); //erstellet eine Liste zum ausgeben
		
		result.add(current.wert);	//fgt wert der ausgabeliste hinzu
		
			for(int i = 0; i < this.size(); i++) {	
				for(int j = 0; j < s.size(); j++) { 
					if(result.contains(current.wert) == false) { //wenn result bereits den wert enthlt wird er nicht hinzugefgt
						result.add(current.wert);//fgt den wert hinzu
					}
					if(result.contains(current2.wert) == false) { //wenn result bereits den wert enthlt wird er nicht hinzugefgt
						result.add(current2.wert);//fgt den wert hinzu
					}
					current2 = current2.next; //geht zur nchsetn variable der zweiten liste
				}
				current = current.next; //geht zur nchsten variable der ersten liste
				current2 = s.start;	//current der zweiten liste wird zum start der zweiten eingegebenen liste
			}
			return result; //gibt die ausgabeliste zurck
		}
	
	public Set<X> difference(Set<X> s) {	//methode die alle variablen die nur in der ersten nicht in der zweiten liste sind in eine extra ausgabeliste packt
		Node<X> current = this.start;	//initialisiert die liste
		Set<X> result = new Set<X>();	//erstellt neue liste zum ausgeben
		
			for(int i = 0; i < this.size(); i++) {	
				for(int j = 0; j < s.size(); j++) {
					if(result.contains(current.wert) == false) //wenn result den wert nicht enthlt
						if(s.contains(current.wert) == false) {//wenn s den wert nicht enthlt
							result.add(current.wert); //wert wird zu result hinzugefgt
					}
				}
				current = current.next; //nchste variable
			}
			return result;//gibt die Ausgabeliste zurck
	}
	
	public boolean subset(Set<X> s) {	//Methode die kontrolliert ob alle variablen in der eingegebnene Liste auchn in der ersten Liste sind
        Node<X> current2 = s.start;	//initialisiert die liste s
        while(current2 != null) { //wrend der nchste wert ungleich null ist
            if(this.contains(current2.wert) == true) { //wenn die erste liste den wert enthlt
                 current2 = current2.next;	//zur nchsten variable gehen
            } else {
            	return false;	//wenn nicht abbrechen
            }
        }
        return true; //falls alle drinnen sind true zurck geben

    }
	
	public Node<X> getStart() { //erstellt start zum getten
		return this.start;		//gibt start zurück
	}
	
	public int size() {	//erstellt size zum getten
		return this.size;	//gibt size zurück
	}
	
	public void Ausgabe() {
		Node<X> current = this.start;	//initialisiert die liste
		
	while(current != null) {	//solange current also der aktuelle Wert ungleich "null" ist
		System.out.print(current.wert + " ");	//gibt den aktuellen Wert aus
		current = current.next;	//geht zum nächsten Wert
	}System.out.print("\n");
}
	
}
